# Anomaly detection in Time Series

- Component : Anomaly diagnostic based on counterfactual analysis
- Responsible : Fred Ngolé Mboula (CEA)

## Sparsity based anomaly detection framework

This module performs anomalous segments detection in univariate time series, leveraging their structural similarities.
A multiscale representation of the signal is derived to enable the detection of anomalous segments of unprescribed lengths.
As an important by-product, a pattern-based time series dissimilarity metric is provided.

### Step 1

Download the codes and training data and go to the `Sparsity Based Anomaly Detection/` directory

```
git clone https://git.irt-systemx.fr/confianceai/ec_5/ec5_as3/counterfactual-anomaly-detection.git
cd counterfactual-anomaly-detection/
```

### Step 2

Create, activate a virtual environment and install requirements

```
python -m venv myvenv
source myvenv/bin/activate
pip install -r requirements.txt
```

### Step 3

Run the notebook `example_synth.ipynb` in `examples/` directory to test the method on synthetic signals.
